package cn.iocoder.yudao.module.smartfactory.service.handlinggroup;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.module.smartfactory.controller.admin.handlinggroup.vo.HandlingGroupPageReqVO;
import cn.iocoder.yudao.module.smartfactory.controller.admin.handlinggroup.vo.HandlingGroupSaveReqVO;
import cn.iocoder.yudao.module.smartfactory.dal.dataobject.handlinggroup.HandlingGroupDO;
import cn.iocoder.yudao.module.smartfactory.dal.mysql.handlinggroup.HandlingGroupMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

/**
 * 搬运组 Service 实现类
 *
 * @author 艾楷
 */
@Service
@Validated
public class HandlingGroupServiceImpl extends ServiceImpl<HandlingGroupMapper, HandlingGroupDO> implements HandlingGroupService {

    @Resource
    private HandlingGroupMapper handlingGroupMapper;

    @Override
    public Long createHandlingGroup(HandlingGroupSaveReqVO createReqVO) {
        // 插入
        HandlingGroupDO handlingGroup = BeanUtils.toBean(createReqVO, HandlingGroupDO.class);
        handlingGroupMapper.insert(handlingGroup);
        // 返回
        return handlingGroup.getId();
    }

    @Override
    public void updateHandlingGroup(HandlingGroupSaveReqVO updateReqVO) {
        // 更新
        HandlingGroupDO updateObj = BeanUtils.toBean(updateReqVO, HandlingGroupDO.class);
        handlingGroupMapper.updateById(updateObj);
    }

    @Override
    public void deleteHandlingGroup(Long id) {
        // 删除
        handlingGroupMapper.deleteById(id);
    }


    @Override
    public HandlingGroupDO getHandlingGroup(Long id) {
        return handlingGroupMapper.getHandlingGroup(id);
    }

    @Override
    public PageResult<HandlingGroupDO> getHandlingGroupPage(HandlingGroupPageReqVO pageReqVO) {
        IPage<HandlingGroupDO> pageResult = handlingGroupMapper.selectPageList(MyBatisUtils.buildPage(pageReqVO), pageReqVO);
        return new PageResult<>(pageResult.getRecords(), pageResult.getTotal());
    }

}
